C SIMULTANEOUS TRANSFORMATION SUBROUTINE AND TEST PROGRAM FOR MAP PROJECT

C COPYRIGHT S J JONES & H K D H BHADESHIA
C           DEPT OF MATERIALS SCIENCE & METALLURGY
C           UNIVERSITY OF CAMBRIDGE
C           UNITED KINGDOM

      PROGRAM MAP_STEEL_SIM_TRANS_EX
      IMPLICIT NONE
      DOUBLE PRECISION DTIME,PARA1D,PARA3D,DIFFUSY,GRWID,AR
      DOUBLE PRECISION ARWID,VIWID,EQVOLFRAC,OBOUND,VIINCA
      DOUBLE PRECISION VIINCWID,VIA
C
      DOUBLE PRECISION TIME,PRETIME,PERCENTRANS,VTOTTRANS,
     &VAREAL,VWIDREAL,VAREALINC,VWIDREALINC,SATTIME
C
      INTEGER I100,IFLAG
C
      READ(*,*) DTIME,PARA1D,PARA3D,DIFFUSY,GRWID,AR,ARWID,
     &VIINCA,VIINCWID,VIA,VIWID,EQVOLFRAC,OBOUND
      TIME=0.0
      DO 100 I100=1,10,1
       PRETIME=TIME
       TIME=DTIME*I100
       CALL MAP_STEEL_SIM_TRANS(I100,TIME,PRETIME,DTIME,PARA1D,PARA3D,
     & DIFFUSY,GRWID,AR,ARWID,VIINCA,VIINCWID,VIA,VIWID,
     & EQVOLFRAC,OBOUND,PERCENTRANS,VTOTTRANS,VAREAL,
     & VWIDREAL,VAREALINC,VWIDREALINC,IFLAG,SATTIME)
       WRITE(*,200) TIME,VTOTTRANS,VAREAL,VWIDREAL,
     & VAREALINC,VWIDREALINC
       IF (PERCENTRANS.GE.100.0) GOTO 300
100   CONTINUE
200   FORMAT(E10.3,1X,E10.3,1X,E10.3,1X,E10.3,1X,E10.3,1X,E10.3)
300   STOP
      END
C**********************************************************************


      SUBROUTINE MAP_STEEL_SIM_TRANS(I2,TIME,PRETIME,DTIME,PARA1D,
     &PARA3D,DIFFUSY,GRWID,AR,ARWID,VIINCA,VIINCWID,VIA,VIWID,
     &EQVOLFRAC,OBOUND,PERCENTRANS,VTOTTRANS,VAREAL,
     &VWIDREAL,VAREALINC,VWIDREALINC,IFLAG,SATTIME)


       IMPLICIT NONE

       DOUBLE PRECISION
     &QA(1001),PREQA(1001),OREA(3000),PREOREA(3000),QWID(1001),
     &PREQWID(1001),OREWID(3000),PREOREWID(3000),Y(3000),
     &NOPARTINCA(1001),NOPARTINCWID(1001),NOPARTGBA(1001),
     &NOPARTGBWID(1001),TIMEOFNUCL(1001)
C
      DOUBLE PRECISION TIME,PRETIME,DTIME,PARA1D,PARA3D,DIFFUSY,
     &GRWID,AR,ARWID,VIINCA,VIINCWID,VIA,VIWID,EQVOLFRAC,OBOUND,
     &PERCENTRANS,VTOTTRANS,VAREAL,VWIDREAL,VAREALINC,VWIDREALINC,
     &SATTIME,PI,VOLTOT,YEND,DYSMA,DYMED,DYLAR,SUMINCA,
     &SUMINCWID,TIMESNINC,NEWCONINCA,NEWCONINCWID,
     &DVEXTAINC,DVEXTWIDINC,TIMESN,
     &MAXHGTA,MAXHGTWID,MAXHGT,ALLA,ALLWID,DOEXA,
     &DOEXWID,DOREA,DOREWID,FRACOBUT,PORA,PORWID,PREVAEXT,
     &VAEXT,PREVWIDEXT,VWIDEXT,DVAEXT,DVWIDEXT,FRACUT,
     &DVAREALINC,DVAREAL,
     &VTOTAREAL,PREVTFERR,GROWCONINCA,QAINCRE,
     &GROWCONINCWID,QWIDINCRE,DVWIDREALINC,DVWIDREAL,VTOTWIDREAL
C
      INTEGER I2,IFLAG,INOSMA,INOMED,INOLAR,IYPLANE,I20,
     &I610,I642,I810,I10,I400,I500
C
      PARAMETER (PI=3.141592654)
C ****************************************************************************
C ****************************************************************************

C SIMULTANEOUS TRANSFORMATION MODULE:

C ****************************************************************************
C ****************************************************************************
C
       SAVE
C
       IF (I2.EQ.1) THEN

C SET TOTAL ASSEMBLY VOLUME=1.0 THEREFORE VOLUMES = VOLUME FRACTIONS::


        VOLTOT=1.0


C USED TO VARY THE DISTANCE 'Y' TO THE RANDOM PLANE PARALLEL TO THE GB.
C THESE MUST REMAIN THE SAME AS THEY ARE DEVELOPED ITERATIVELY.

C CONSIDER 3 INTERVAL SIZES BECAUSE THE GROWTH RATES OF DISPLACIVE
C PLATES IS MUCH GREATER THAN ALLOTRIOMORPHIC FERRITE NEED SMALL DY
C NEAR THE BOUNDARY - HOWEVER FURTHER AWAY LARGER INTERVAL IS
C REDUCES THE COMPUTATIONAL EFFORT (NOTE - CONSIDER EXTENDED
C PARTICLE SIZE)

C DYSMA=0.01D-6 M FROM Y = 0 TO 10D-6 M
C DYMED=1.D-6 M FROM Y = 10D-6 TO 1000D-6 M
C DYLAR=10D-6 M FROM Y = 1000D-6 TO 10000D-6 M

C THIS REQUIRES THAT 1001 SMALL STEPS, 990 MEDIUM STEPS, 900 LARGE STEPS:

       INOSMA=1001
       INOMED=990
       INOLAR=900
       
       IYPLANE=INOSMA+INOMED+INOLAR
       YEND=10000.0D-6

       DYSMA=0.01D-6
       DYMED=1.0D-6
       DYLAR=10.0D-6

C VARY 'Y' HGT OF PLANE TO BE CONSIDERED - ZERO (AT GB) ON FIRST LOOP:

C REFER TO INSTRUCTIONS NEAR START OF PROGRAM DY VARIED ACCORDING TO Y:
 

       DO 810 I810=1,IYPLANE,1
    
        IF (I810.LE.INOSMA) THEN
         Y(I810)=1.0*((I810-1)*DYSMA)
        ELSEIF ((I810.GT.INOSMA).AND.(I810.LE.(INOSMA+INOMED))) THEN
         Y(I810)=Y(INOSMA)+1.0*((I810-INOSMA)*DYMED)
        ELSE
         Y(I810)=Y(INOSMA+INOMED)+1.0*((I810-INOSMA-INOMED)*DYLAR)
        ENDIF

        IF (I810.EQ.INOSMA) THEN
         Y(I810)=Y(I810)
        ELSEIF (I810.EQ.(INOSMA+INOMED)) THEN
         Y(I810)=Y(I810)
        ELSEIF (I810.EQ.IYPLANE) THEN
         Y(I810)=Y(I810)
        ENDIF

810    CONTINUE



        IFLAG=0


        ENDIF




C STORE TIME OF NUCLEATION OF PARTICLES NUC (THUS CAN VARY DT)

          TIMEOFNUCL(I2)=PRETIME




C ****************************************************************************


C CALCULATION OF INCLUSION


C CALCULATION OF EXTENDED VOLUME INCREMENT FOR ALLOTRIOMORPHIC FERRITE
C & WIDMAN. FERRITE NUCLEATED ON AN INCLUSION:

C NB REMEMBER WE REQUIRE THE CHANGE IN THE EXTENDED VOLUME DUE TO
C ALL CLASSES OF NUCLEI - THE NUMBER OF EACH IS FOUND FROM THE
C THE NUCLEATION RATE AT THE TIME OF NUCLEATION - HOWEVER - ADDITIONAL
C GROWTH IS DETERMINED FROM CURRENT GROWTH CONDITIONS.





C STORE NO OF PARTICLES NUC AT 'START' OF THIS TIME INTERVAL
C NEED TO STORE BECAUSE TIME INTERAVL ALLOWED TO VARY

          NOPARTINCA(I2)=VIINCA*DTIME*VOLTOT
          NOPARTINCWID(I2)=VIINCWID*DTIME*VOLTOT

C RESET:
        
        SUMINCA=0.0
        SUMINCWID=0.0 
 

        DO 610 I610=1,I2,1


C TIME SINCE NUC. OF THIS CLASS TO THE START OF THIS LAST INTERVAL:

          TIMESNINC=PRETIME-TIMEOFNUCL(I610)

C I610 REFERS TO TIME CLASS OF PARTICLES WAS NUCLEATED - IGNORE PARTICLES
C NUCLEATED AT CURRENT TIME - HAVE NO VOLUME AS YET.


C ALWAYS CONSIDER GROWTH CONDITIONS AT START OF FINAL TIME INCREMENT

C NOTE PARTICLES JUST NUCLEATED IE. I610=I2 HAVE ZERO VOLUME


         IF (I610.EQ.I2) THEN

C PARTICLE JUST NUCLEATED - LAST INTERVAL:

          NEWCONINCA=NOPARTINCA(I610)*(4.0*PI/3.0)
     &    *(PARA3D**3.0)
     &    *(DIFFUSY**1.5)*(DTIME**1.5)

          NEWCONINCWID=NOPARTINCWID(I610)
     &    *ARWID*(DTIME**3.0)*(GRWID**3.0)

          SUMINCA=SUMINCA+NEWCONINCA
          SUMINCWID=SUMINCWID+NEWCONINCWID

         ELSE

C PARTICLE AREADY NUCLEATED - CALC. INCREMENT IN VOL IN THIS INTERVAL:

          GROWCONINCA=NOPARTINCA(I610)*(4.0*PI/3.0)
     &    *(3.0/2.0)*(PARA3D**3.0)
     &    *(DIFFUSY**1.5)*DTIME*(TIMESNINC**0.5)

          GROWCONINCWID=NOPARTINCWID(I610)
     &    *ARWID*3.0*(GRWID**3.0)
     &    *DTIME*(TIMESNINC**2.0)

          SUMINCA=SUMINCA+GROWCONINCA
          SUMINCWID=SUMINCWID+GROWCONINCWID

         ENDIF
                  
610      CONTINUE     

C RENAME INCREMENTS IN EXTENDED INC VOLUMES FOR THIS TIME INTERVAL:

         DVEXTAINC=SUMINCA
         DVEXTWIDINC=SUMINCWID

C NB CONVERSION FROM EXTENDED TO REAL VOLUMES NEAR END OF PROGRAM.



C ****************************************************************************

C CALCULATION OF GRAIN BOUNDARY NUCLEATION & GROWTH

C THIS LOOP CALCULATES THE NEW DISC HGT 'Q' FOR THE NEW TIME
C CONSIDERS ALL PRECEEDING  ISOTHERMAL TIME INTERVALS -
C INDEPENDENT OF 'Y'

C CALC HGT AT CURRENT TIME=(I2-1)*DTIME) NOTE CONSIDER GROWTH CONDITIONS
C AT START OF LAST INTERVAL IE. ELEMENT(I2-1)


C STORE NO OF PARTICLES NUC ON GB AT 'START' OF THIS TIME INTERVAL
C NEED TO STORE BECAUSE TIME INTERVAL ALLOWED TO VARY

          NOPARTGBA(I2)=VIA*DTIME*OBOUND
          NOPARTGBWID(I2)=VIWID*DTIME*OBOUND


       DO 20 I20=1,I2,1

C NB WE CONSIDER DA/DT AT START OF LAST INTERVAL.

C TIME SINCE NUC. OF THIS CLASS TO THE START OF THIS LAST INTERVAL
C NEW METHOD TO ALLOW FOR VARIABLE TIME INTERVAL DTIME:

       TIMESN=PRETIME-TIMEOFNUCL(I20)

       IF (TIMESN.LT.(0.000001*DTIME)) THEN

C TO IMPROVE ACCURACY - IF PARTICLE NUCLEATED AT START OF LAST INTERVAL

C RECONSTRUCTIVE DISC:

        PREQA(I20)=0.0
        QA(I20)=PARA1D*(DIFFUSY**0.5)*(DTIME**0.5)

C PLATE WIDM. FERRITE:

        PREQWID(I20)=0.0
        QWID(I20)=GRWID*DTIME

       ELSE

C EXISTING PARTICLE:

C CALCULATE NEW PARTICLE HGT. BY ADDING INCREMENT TO PREVIOUS VALUE:

C RECONSTRUCTIVE DISC:

        QAINCRE=0.5*PARA1D*(DIFFUSY**0.5)
     &  *((TIMESN)**(-0.5))*DTIME

        PREQA(I20)=QA(I20)

        QA(I20)=QA(I20)+QAINCRE

C PLATE WIDM. FERRITE:

        QWIDINCRE=GRWID*DTIME

        PREQWID(I20)=QWID(I20)

        QWID(I20)=QWID(I20)+QWIDINCRE

       ENDIF

20     CONTINUE

C FOR MODEL VALIDITY - CHECK THAT NO GB DISCS HAVE A HGT GRATER THAN YEND
C ONLY CONSIDER THOSE 'REAL' DISCS IE. THOSE WHICH HAVE FORMED WHEN THE
C NUCLEATION RATE WAS NOT ZERO.

C FIND THE MAXHGT OF QA AND QWID AT THIS TIME:

       MAXHGTA=0.0
       MAXHGTWID=0.0

       DO 642 I642=1,I2,1

       IF (QA(I642).GT.MAXHGTA) THEN
        MAXHGTA=QA(I642)
       ENDIF

       IF (QWID(I642).GT.MAXHGTWID) THEN
        MAXHGTWID=QWID(I642)
       ENDIF

642    CONTINUE

       IF (MAXHGTWID.GE.MAXHGTA) THEN
        MAXHGT=MAXHGTWID
       ELSE
        MAXHGT=MAXHGTA
       ENDIF
        

C TEST MAXHGT DOES NOT EXCEED YEND:

       IF (MAXHGT.GT.YEND) THEN
         WRITE(*,*) "YEND TOO SMALL - ERROR !"
         PAUSE
       ENDIF
       
       


C COMPARE PARTICLE HGT WITH Y ETC.....

       DO 10 I10=1,IYPLANE,1

C INCREMENTAL INCREASE IN EXTENDED AREAS OF ALL. AND WID. FOR EACH 'Y'
C VALUE - DO THIS BY SUMMING ALL CONTRIBUTIONS WHERE QX>=Y DURING 
C TIME INTERVAL T=TOR TO T=TOR+DTOR - NOTE HAVE TO CONSIDER ALL CLASSES
C OF DISC.

C RESET TO ZERO:
         ALLA=0.0
         ALLWID=0.0


C MODIFIED TO REDUCE COMPUTATION TIME - ONLY CONSIDER THOSE Y PLANES
C THAT INTERSECT EITHER A OR B TYPE DISCS - NO NEED TO RESET BECAUSE
C DISCS GET BIGGER WITH TIME !


        IF (MAXHGT.GT.Y(I10)) THEN


        DO 400 I400=1,I2,1

C TIME SINCE NUC. OF THIS CLASS TO THE STRT OF THIS LAST INTERVAL:

        TIMESN=PRETIME-TIMEOFNUCL(I400)

C TEST IF ALLOT. CLASS OF PARTICLES REACH Y:

        IF (QA(I400).GE.Y(I10)) THEN
C IS THE FIRST TIME THAT THIS CLASS OF A PARTICLE HAS REACHED Y.
         IF ((PREQA(I400).LT.Y(I10)).OR.
     &   (TIMESN.LT.(0.000001*DTIME))) THEN

C ADD ALL OF CURRENT AREA OF A PARTICLE TO INCREMENT IN EXTENDED AREA
C MUST CALC. FROM SIZE ARRAY BEACAUSE OF VARYING GROWTH CONDITIONS:

          ALLA=ALLA+(NOPARTGBA(I400))*(PI*((AR*QA(I400))**2))

         ELSE
C ONLY NEED TO ACCOUNT FOR INCREASE IN AREA CONTRIBUTED BY THIS CLASS.

          ALLA=ALLA+
     &    NOPARTGBA(I400)*DTIME*((PARA1D*AR)**2)*PI*DIFFUSY

         ENDIF
        ENDIF


C TEST IF WIDMAN. CLASS OF PARTICLES REACH Y:

        IF (QWID(I400).GE.Y(I10)) THEN
C IS THE FIRST TIME THAT THIS CLASS OF A PARTICLE HAS REACHED Y.
         IF ((PREQWID(I400).LT.Y(I10)).OR.
     &   (TIMESN.LT.(0.000001*DTIME))) THEN

C ADD ALL OF CURRENT AREA OF A PARTICLE TO INCREMENT IN EXTENDED AREA
C MUST CALC. FROM SIZE ARRAY BEACAUSE OF VARYING GROWTH CONDITIONS:

          ALLWID=ALLWID
     &    +( (NOPARTGBWID(I400))*(ARWID*(QWID(I400)**2.0)) )

         ELSE
C ONLY NEED TO ACCOUNT FOR INCREASE IN AREA CONTRIBUTED BY THIS CLASS.

          ALLWID=ALLWID
     &    +( 2.0*(NOPARTGBWID(I400))*ARWID*(GRWID**2.0) 
     &    * TIMESN * DTIME )

         ENDIF
        ENDIF

400     CONTINUE

        ELSE

C NO DISCS OR PLATES REACH THIS Y:
 
         ALLA=0.0
         ALLWID=0.0     

        ENDIF


C CONVERSION TO REAL AREAS ETC.......


C RENAME THESE EXTENDED INCREMENTS FOR THE CURRENT VALUE OF Y:
         DOEXA=ALLA
         DOEXWID=ALLWID

C CONVERT TO REAL INCREMENTS FOR THE CURRENT VALUE OF Y REPESENTED BY I10
C - USING PREVIOUS TIME VALUES OF OREA(Y):

        IF (I2.EQ.1) THEN

         DOREA=DOEXA
         DOREWID=DOEXWID

        ELSE
C CALCULATE THE FRACTION OF THE AREA OF THE PLANE AT 'Y' WHICH REMAINS
C UNTRANSFORMED AT THIS TIME. NB DO NOT LET THIS FALL BELOW ZERO!

        IF ((OREA(I10)+OREWID(I10)).GE.OBOUND) THEN
         FRACOBUT=0.0
        ELSE
         FRACOBUT=(1.0-(OREA(I10)+OREWID(I10))/OBOUND)
        ENDIF

        DOREA=DOEXA*FRACOBUT
        DOREWID=DOEXWID*FRACOBUT


       ENDIF

C SUM TO FIND TOTAL EXTENDED AREAS OF 'A' AND 'B' FOR THIS 'Y' AND 'TOR'
C IE. NEW VALUS OF OREA

C STORE PREV. VALUES IF THEIR TOTAL STILL <= OBOUND

       IF ((OREA(I10)+OREWID(I10)).LE.OBOUND) THEN
        PREOREA(I10)=OREA(I10)
        PREOREWID(I10)=OREWID(I10)
       ENDIF

         OREA(I10)=OREA(I10)+DOREA
         OREWID(I10)=OREWID(I10)+DOREWID


C ENSURE THAT TOTAL EXTENDED AREAS OF 'A' AND 'B' FOR THIS 'Y' NEVER
C EXCEEDS OBOUND IF DO SET = OBOUND:

       IF ((OREA(I10)+OREWID(I10)).GT.OBOUND) THEN

C USE LAST VALID PROPORTIONS TO SET VALUES SUCH THAT SUM = OBOUND:

         IF ((PREOREA(I10)+PREOREWID(I10)).GT.0.0) THEN
   
          PORA=PREOREA(I10)/(PREOREA(I10)+PREOREWID(I10))
          PORWID=PREOREWID(I10)/(PREOREA(I10)+PREOREWID(I10))

         ELSE

C IF NO PREVIOUS VALID VALUES ADJUST CURRENT SUCH THAT TOTAL = OBOUND:

          PORA=OREA(I10)/(OREA(I10)+OREWID(I10))
          PORWID=OREWID(I10)/(OREA(I10)+OREWID(I10))


         ENDIF

         OREA(I10)=PORA*OBOUND
         OREWID(I10)=PORWID*OBOUND


       ENDIF

C NOTE TIME WHEN SITE SATUARTION AT GB (Y=0.0 I10=1) OCCURS:

         IF ( (I10.EQ.1).AND.(IFLAG.EQ.0) ) THEN
           IF ( (OREA(I10)+OREWID(I10)) .GE. (0.99*OBOUND) ) THEN
             SATTIME=TIME
             IFLAG=1
           ENDIF
         ENDIF



10     CONTINUE


C SUM FOR ALL Y:

C RECONSTRUCTIVE - TWICE TO ALLOW FOR GROWTH ON BOTH SIDES OF THE GB
C DISPLACIVE - ONCE TO ALLOW FOR GROWTH ON ONE SIDE OF THE GB


C STORE PREVIOUS VALUES:

888    PREVAEXT=VAEXT
       PREVWIDEXT=VWIDEXT

C USE TRAPEZIUM TYPE METHODS - NOTE:

C DYSMA=0.01D-6 M FROM Y = 0 TO 10D-6 M
C DYMED=1.D-6 M FROM Y = 10D-6 TO 1000D-6 M
C DYLAR=10D-6 M FROM Y = 1000D-6 TO 10000D-6 M

C THEREFORE REQUIRE 3 TRAPEZIUM TYPE CALC FOR EACH GB NUC. PHASE:

C CALC. 3 PAIRS OF HALF INTERVAL AT THE START AND FINISH OF EACH RANGE

        VAEXT=( 2.0*0.5*DYSMA*( OREA(1)
     &          +OREA(INOSMA) ) )
     &        +( 2.0*0.5*DYMED*( OREA(INOSMA+1)
     &          +OREA(INOSMA+INOMED) ) )
     &        +( 2.0*0.5*DYLAR*( OREA(INOSMA+INOMED+1)
     &          +OREA(IYPLANE) ) )


        VWIDEXT=( 1.0*0.5*DYSMA*( OREWID(1)
     &          +OREWID(INOSMA) ) )
     &        +( 1.0*0.5*DYMED*( OREWID(INOSMA+1)
     &          +OREWID(INOSMA+INOMED) ) )
     &        +( 1.0*0.5*DYLAR*( OREWID(INOSMA+INOMED+1)
     &          +OREWID(IYPLANE) ) )


        DO 500 I500=2,(IYPLANE-1),1

        IF ( (I500.GT.1).AND.(I500.LT.INOSMA) ) THEN

          VAEXT=VAEXT+(2.0*DYSMA*OREA(I500))
          VWIDEXT=VWIDEXT+(1.0*DYSMA*OREWID(I500))

        ELSEIF ((I500.GT.(INOSMA+1)).AND.(I500.LT.(INOSMA+INOMED))) THEN

          VAEXT=VAEXT+(2.0*DYMED*OREA(I500))
          VWIDEXT=VWIDEXT+(1.0*DYMED*OREWID(I500))

        ELSEIF((I500.GT.(INOSMA+INOMED+1)).AND.(I500.LT.(IYPLANE))) THEN

          VAEXT=VAEXT+(2.0*DYLAR*OREA(I500))
          VWIDEXT=VWIDEXT+(1.0*DYLAR*OREWID(I500))

        ENDIF


500     CONTINUE


C THESE VOLUMES ARE EXTENDED WITH RESPECT TO OTHER GB AND INCLUSION
C NUCLEATED PRODUCTS - CAN CALCULATE MORE RIGOUROUSLY IE. SUM
C ALL INCREMENTS IN REAL AREA - GIVES EXACTLY SAME RESULT NUMERICALLY.

        IF (I2.EQ.1) THEN
         DVAEXT=VAEXT
         DVWIDEXT=VWIDEXT

        ELSE
         DVAEXT=VAEXT-PREVAEXT
         DVWIDEXT=VWIDEXT-PREVWIDEXT

        ENDIF

C CONVERT TO REAL INCREMENTS (IT IS HERE THAT INCLUSION NUCLEATION CAN BE
C COMBINED) ESTIMATE VOLUME FRACTION UNTRANSFORMED FROM PREVIOUS TIME:

C PREVIOUS FRACTION UNTRANSFORMED=FRACUT

         FRACUT=(1.0-(VAREALINC+VAREAL+VWIDREALINC+VWIDREAL)
     &   /VOLTOT)

C CONVERT INC INCREMENTS TO REAL:

         DVAREALINC=DVEXTAINC*FRACUT
         DVWIDREALINC=DVEXTWIDINC*FRACUT

C ADD TO PREVIOUS INC TOTAL REAL VOLMES:

         VAREALINC=VAREALINC+DVAREALINC
         VWIDREALINC=VWIDREALINC+DVWIDREALINC

C CONVERT GB INCREMENTS TO REAL:

         DVAREAL=DVAEXT*FRACUT
         DVWIDREAL=DVWIDEXT*FRACUT

C ADD TO PREVIOUS GB TOTAL REAL VOLMES:

         VAREAL=VAREAL+DVAREAL
         VWIDREAL=VWIDREAL+DVWIDREAL

C TOTAL REAL RECON. 'A' INC AND GB:

         VTOTAREAL=VAREAL+VAREALINC

C TOTAL REAL DISP. 'WID' INC AND GB:

         VTOTWIDREAL=VWIDREAL+VWIDREALINC

C TOTAL FERRITE - ONLY RECON. AND WID. FOR NOW (STORE PREV)
             
         PREVTFERR=VTOTTRANS
         VTOTTRANS=VTOTWIDREAL+VTOTAREAL

        PERCENTRANS=(VTOTTRANS/EQVOLFRAC)*100.0
C
        RETURN
C
        END





C*************************************************************************
